--- xpdf-3.02/xpdf/Function.cc
+++ xpdf-3.02/xpdf/Function.cc
@@ -212,7 +212,7 @@
   }
 
   //----- buffer
-  sBuf = (double *)gmallocn(1 << m, sizeof(double));
+  sBuf = (double *)gmallocn((SafeInt(1) << m).Int(), sizeof(double));
 
   //----- get the stream
   if (!funcObj->isStream()) {
@@ -364,8 +364,8 @@
 SampledFunction::SampledFunction(SampledFunction *func) {
   memcpy(this, func, sizeof(SampledFunction));
   samples = (double *)gmallocn(nSamples, sizeof(double));
-  memcpy(samples, func->samples, nSamples * sizeof(double));
-  sBuf = (double *)gmallocn(1 << m, sizeof(double));
+  memcpy(samples, func->samples, (nSamples * sizeof(double)).Int());
+  sBuf = (double *)gmallocn((SafeInt(1) << m).Int(), sizeof(double));
 }
 
 void SampledFunction::transform(double *in, double *out) {
@@ -570,8 +570,8 @@
   }
   k = obj1.arrayGetLength();
   funcs = (Function **)gmallocn(k, sizeof(Function *));
-  bounds = (double *)gmallocn(k + 1, sizeof(double));
-  encode = (double *)gmallocn(2 * k, sizeof(double));
+  bounds = (double *)gmallocn(k + SafeInt(1), sizeof(double));
+  encode = (double *)gmallocn(SafeInt(2) * k, sizeof(double));
   scale = (double *)gmallocn(k, sizeof(double));
   for (i = 0; i < k; ++i) {
     funcs[i] = NULL;
@@ -604,7 +604,7 @@
     bounds[i] = obj2.getNum();
     obj2.free();
   }
-  bounds[k] = domain[0][1];
+  bounds[k.Int()] = domain[0][1];
   obj1.free();
 
   //----- Encode
@@ -651,12 +651,12 @@
   for (i = 0; i < k; ++i) {
     funcs[i] = func->funcs[i]->copy();
   }
-  bounds = (double *)gmallocn(k + 1, sizeof(double));
-  memcpy(bounds, func->bounds, (k + 1) * sizeof(double));
-  encode = (double *)gmallocn(2 * k, sizeof(double));
-  memcpy(encode, func->encode, 2 * k * sizeof(double));
+  bounds = (double *)gmallocn(k + SafeInt(1), sizeof(double));
+  memcpy(bounds, func->bounds, ((k + 1) * sizeof(double)).Int());
+  encode = (double *)gmallocn(SafeInt(2) * k, sizeof(double));
+  memcpy(encode, func->encode, (2 * k * sizeof(double)).Int());
   scale = (double *)gmallocn(k, sizeof(double));
-  memcpy(scale, func->scale, k * sizeof(double));
+  memcpy(scale, func->scale, (k * sizeof(double)).Int());
   ok = gTrue;
 }
 
@@ -1051,7 +1051,7 @@
 PostScriptFunction::PostScriptFunction(PostScriptFunction *func) {
   memcpy(this, func, sizeof(PostScriptFunction));
   code = (PSObject *)gmallocn(codeSize, sizeof(PSObject));
-  memcpy(code, func->code, codeSize * sizeof(PSObject));
+  memcpy(code, func->code, (codeSize * sizeof(PSObject)).Int());
   codeString = func->codeString->copy();
 }
 
--- xpdf-3.02/xpdf/Function.h
+++ xpdf-3.02/xpdf/Function.h
@@ -131,7 +131,7 @@
     inputMul[funcMaxInputs];
   int idxMul[funcMaxInputs];	// sample array index multipliers
   double *samples;		// the samples
-  int nSamples;			// size of the samples array
+  SafeInt nSamples;		// size of the samples array
   double *sBuf;			// buffer for the transform function
   GBool ok;
 };
@@ -178,7 +178,7 @@
   virtual void transform(double *in, double *out);
   virtual GBool isOk() { return ok; }
 
-  int getNumFuncs() { return k; }
+  int getNumFuncs() { return k.Int(); }
   Function *getFunc(int i) { return funcs[i]; }
   double *getBounds() { return bounds; }
   double *getEncode() { return encode; }
@@ -188,7 +188,7 @@
 
   StitchingFunction(StitchingFunction *func);
 
-  int k;
+  SafeInt k;
   Function **funcs;
   double *bounds;
   double *encode;
@@ -222,7 +222,7 @@
 
   GString *codeString;
   PSObject *code;
-  int codeSize;
+  SafeInt codeSize;
   GBool ok;
 };
 
--- xpdf-3.02/xpdf/GfxFont.cc
+++ xpdf-3.02/xpdf/GfxFont.cc
@@ -368,7 +368,8 @@
   Object obj1, obj2;
   Stream *str;
   int c;
-  int size, i;
+  SafeInt size;
+  int i;
 
   obj1.initRef(embFontID.num, embFontID.gen);
   obj1.fetch(xref, &obj2);
@@ -382,12 +383,12 @@
   str = obj2.getStream();
 
   buf = NULL;
-  i = size = 0;
+  size = i = 0;
   str->reset();
   while ((c = str->getChar()) != EOF) {
     if (i == size) {
       size += 4096;
-      buf = (char *)grealloc(buf, size);
+      buf = (char *)grealloc(buf, size.Int());
     }
     buf[i++] = c;
   }
@@ -1086,7 +1087,8 @@
   CharCode c;
   Unicode uBuf[8];
   int c1, c2;
-  int excepsSize, i, j, k, n;
+  int j, k, n;
+  SafeInt i, excepsSize;
 
   ascent = 0.95;
   descent = -0.35;
@@ -1247,10 +1249,10 @@
     excepsSize = 0;
     i = 0;
     while (i + 1 < obj1.arrayGetLength()) {
-      obj1.arrayGet(i, &obj2);
-      obj1.arrayGet(i + 1, &obj3);
-      if (obj2.isInt() && obj3.isInt() && i + 2 < obj1.arrayGetLength()) {
-	if (obj1.arrayGet(i + 2, &obj4)->isNum()) {
+      obj1.arrayGet(i.Int(), &obj2);
+      obj1.arrayGet((i + 1).Int(), &obj3);
+      if (obj2.isInt() && obj3.isInt() && (i + 2).Int() < obj1.arrayGetLength()) {
+	if (obj1.arrayGet((i + 2).Int(), &obj4)->isNum()) {
 	  if (widths.nExceps == excepsSize) {
 	    excepsSize += 16;
 	    widths.exceps = (GfxFontCIDWidthExcep *)
@@ -1268,7 +1270,7 @@
 	i += 3;
       } else if (obj2.isInt() && obj3.isArray()) {
 	if (widths.nExceps + obj3.arrayGetLength() > excepsSize) {
-	  excepsSize = (widths.nExceps + obj3.arrayGetLength() + 15) & ~15;
+	  excepsSize = (SafeInt(widths.nExceps) + SafeInt(obj3.arrayGetLength()) + 15).Int() & ~15;
 	  widths.exceps = (GfxFontCIDWidthExcep *)
 	    greallocn(widths.exceps,
 		      excepsSize, sizeof(GfxFontCIDWidthExcep));
@@ -1318,12 +1320,12 @@
     excepsSize = 0;
     i = 0;
     while (i + 1 < obj1.arrayGetLength()) {
-      obj1.arrayGet(i, &obj2);
-      obj1.arrayGet(i+ 1, &obj3);
-      if (obj2.isInt() && obj3.isInt() && i + 4 < obj1.arrayGetLength()) {
-	if (obj1.arrayGet(i + 2, &obj4)->isNum() &&
-	    obj1.arrayGet(i + 3, &obj5)->isNum() &&
-	    obj1.arrayGet(i + 4, &obj6)->isNum()) {
+      obj1.arrayGet(i.Int(), &obj2);
+      obj1.arrayGet((i+ 1).Int(), &obj3);
+      if (obj2.isInt() && obj3.isInt() && (i + 4).Int() < obj1.arrayGetLength()) {
+	if (obj1.arrayGet((i + 2).Int(), &obj4)->isNum() &&
+	    obj1.arrayGet((i + 3).Int(), &obj5)->isNum() &&
+	    obj1.arrayGet((i + 4).Int(), &obj6)->isNum()) {
 	  if (widths.nExcepsV == excepsSize) {
 	    excepsSize += 16;
 	    widths.excepsV = (GfxFontCIDWidthExcepV *)
@@ -1511,7 +1513,7 @@
   Unicode u[64];
   const int ulen = sizeof(u) / sizeof(Unicode);
   int code, i;
-  int mapsize;
+  SafeInt mapsize;
   int cidlen;
 
   *mapsizep = 0;
@@ -1529,7 +1531,7 @@
 
   cidlen = 0;
   mapsize = 64;
-  map = (Gushort *)gmalloc(mapsize * sizeof(Gushort));
+  map = (Gushort *)gmallocn(mapsize, sizeof(Gushort));
 
   while (cidlen < ctu->getMapLen()) {
     int n;
@@ -1540,7 +1542,7 @@
     if (cidlen >= mapsize) {
       while (cidlen >= mapsize)
 	mapsize *= 2;
-      map = (Gushort *)grealloc(map, mapsize * sizeof(Gushort));
+      map = (Gushort *)greallocn(map, mapsize, sizeof(Gushort));
     }
     if (n == 1)
       map[cidlen] = ff->mapCodeToGID(cmap, u[0]);
--- xpdf-3.02/xpdf/GfxState.cc
+++ xpdf-3.02/xpdf/GfxState.cc
@@ -925,7 +925,7 @@
 					   int indexHighA) {
   base = baseA;
   indexHigh = indexHighA;
-  lookup = (Guchar *)gmallocn((indexHigh + 1) * base->getNComps(),
+  lookup = (Guchar *)gmallocn((SafeInt(indexHigh) + SafeInt(1)) * SafeInt(base->getNComps()),
 			      sizeof(Guchar));
 }
 
@@ -2337,7 +2337,7 @@
   vertices = (GfxGouraudVertex *)gmallocn(nVertices, sizeof(GfxGouraudVertex));
   memcpy(vertices, shading->vertices, nVertices * sizeof(GfxGouraudVertex));
   nTriangles = shading->nTriangles;
-  triangles = (int (*)[3])gmallocn(nTriangles * 3, sizeof(int));
+  triangles = (int (*)[3])gmallocn(SafeInt(nTriangles) * SafeInt(3), sizeof(int));
   memcpy(triangles, shading->triangles, nTriangles * 3 * sizeof(int));
   nFuncs = shading->nFuncs;
   for (i = 0; i < nFuncs; ++i) {
@@ -2368,7 +2368,8 @@
   double cMul[gfxColorMaxComps];
   GfxGouraudVertex *verticesA;
   int (*trianglesA)[3];
-  int nComps, nVerticesA, nTrianglesA, vertSize, triSize;
+  int nComps, nVerticesA, nTrianglesA;
+  SafeInt vertSize, triSize;
   Guint x, y, flag;
   Guint c[gfxColorMaxComps];
   GfxShadingBitBuf *bitBuf;
@@ -2506,7 +2507,7 @@
 	if (nTrianglesA == triSize) {
 	  triSize = (triSize == 0) ? 16 : 2 * triSize;
 	  trianglesA = (int (*)[3])
-	                   greallocn(trianglesA, triSize * 3, sizeof(int));
+	                   greallocn(trianglesA, SafeInt(triSize) * SafeInt(3), sizeof(int));
 	}
 	if (state == 2) {
 	  trianglesA[nTrianglesA][0] = nVerticesA - 3;
@@ -2531,8 +2532,9 @@
   delete bitBuf;
   if (typeA == 5) {
     nRows = nVerticesA / vertsPerRow;
-    nTrianglesA = (nRows - 1) * 2 * (vertsPerRow - 1);
-    trianglesA = (int (*)[3])gmallocn(nTrianglesA * 3, sizeof(int));
+    nTrianglesA = ((SafeInt(nRows) - SafeInt(1)) * SafeInt(2) 
+                   * (SafeInt(vertsPerRow) - SafeInt(1))).Int();
+    trianglesA = (int (*)[3])gmallocn(SafeInt(nTrianglesA) * SafeInt(3), sizeof(int));
     k = 0;
     for (i = 0; i < nRows - 1; ++i) {
       for (j = 0; j < vertsPerRow - 1; ++j) {
@@ -2673,7 +2675,8 @@
   double xMul, yMul;
   double cMul[gfxColorMaxComps];
   GfxPatch *patchesA, *p;
-  int nComps, nPatchesA, patchesSize, nPts, nColors;
+  int nComps, nPatchesA, nPts, nColors;
+  SafeInt patchesSize;
   Guint flag;
   double x[16], y[16];
   Guint xi, yi;
@@ -3253,7 +3256,7 @@
     lookup2 = indexedCS->getLookup();
     colorSpace2->getDefaultRanges(x, y, indexHigh);
     for (k = 0; k < nComps2; ++k) {
-      lookup[k] = (GfxColorComp *)gmallocn(maxPixel + 1,
+      lookup[k] = (GfxColorComp *)gmallocn(SafeInt(maxPixel) + SafeInt(1),
 					   sizeof(GfxColorComp));
       for (i = 0; i <= maxPixel; ++i) {
 	j = (int)(decodeLow[0] + (i * decodeRange[0]) / maxPixel + 0.5);
@@ -3272,7 +3275,7 @@
     nComps2 = colorSpace2->getNComps();
     sepFunc = sepCS->getFunc();
     for (k = 0; k < nComps2; ++k) {
-      lookup[k] = (GfxColorComp *)gmallocn(maxPixel + 1,
+      lookup[k] = (GfxColorComp *)gmallocn(SafeInt(maxPixel) + SafeInt(1),
 					   sizeof(GfxColorComp));
       for (i = 0; i <= maxPixel; ++i) {
 	x[0] = decodeLow[0] + (i * decodeRange[0]) / maxPixel;
@@ -3282,7 +3285,7 @@
     }
   } else {
     for (k = 0; k < nComps; ++k) {
-      lookup[k] = (GfxColorComp *)gmallocn(maxPixel + 1,
+      lookup[k] = (GfxColorComp *)gmallocn(SafeInt(maxPixel) + SafeInt(1),
 					   sizeof(GfxColorComp));
       for (i = 0; i <= maxPixel; ++i) {
 	lookup[k][i] = dblToCol(decodeLow[k] +
@@ -3300,7 +3303,8 @@
 }
 
 GfxImageColorMap::GfxImageColorMap(GfxImageColorMap *colorMap) {
-  int n, i, k;
+  int i, k;
+  SafeInt n;
 
   colorSpace = colorMap->colorSpace->copy();
   bits = colorMap->bits;
@@ -3310,23 +3314,23 @@
   for (k = 0; k < gfxColorMaxComps; ++k) {
     lookup[k] = NULL;
   }
-  n = 1 << bits;
+  n = SafeInt(1) << bits;
   if (colorSpace->getMode() == csIndexed) {
     colorSpace2 = ((GfxIndexedColorSpace *)colorSpace)->getBase();
     for (k = 0; k < nComps2; ++k) {
       lookup[k] = (GfxColorComp *)gmallocn(n, sizeof(GfxColorComp));
-      memcpy(lookup[k], colorMap->lookup[k], n * sizeof(GfxColorComp));
+      memcpy(lookup[k], colorMap->lookup[k], n.Int() * sizeof(GfxColorComp));
     }
   } else if (colorSpace->getMode() == csSeparation) {
     colorSpace2 = ((GfxSeparationColorSpace *)colorSpace)->getAlt();
     for (k = 0; k < nComps2; ++k) {
       lookup[k] = (GfxColorComp *)gmallocn(n, sizeof(GfxColorComp));
-      memcpy(lookup[k], colorMap->lookup[k], n * sizeof(GfxColorComp));
+      memcpy(lookup[k], colorMap->lookup[k], n.Int() * sizeof(GfxColorComp));
     }
   } else {
     for (k = 0; k < nComps; ++k) {
       lookup[k] = (GfxColorComp *)gmallocn(n, sizeof(GfxColorComp));
-      memcpy(lookup[k], colorMap->lookup[k], n * sizeof(GfxColorComp));
+      memcpy(lookup[k], colorMap->lookup[k], n.Int() * sizeof(GfxColorComp));
     }
   }
   for (i = 0; i < nComps; ++i) {
@@ -3506,7 +3510,7 @@
 
 // Used for copy().
 GfxPath::GfxPath(GBool justMoved1, double firstX1, double firstY1,
-		 GfxSubpath **subpaths1, int n1, int size1) {
+		 GfxSubpath **subpaths1, SafeInt n1, SafeInt size1) {
   int i;
 
   justMoved = justMoved1;
@@ -3532,11 +3536,11 @@
       subpaths = (GfxSubpath **)
 	           greallocn(subpaths, size, sizeof(GfxSubpath *));
     }
-    subpaths[n] = new GfxSubpath(firstX, firstY);
+    subpaths[n.Int()] = new GfxSubpath(firstX, firstY);
     ++n;
     justMoved = gFalse;
   }
-  subpaths[n-1]->lineTo(x, y);
+  subpaths[n.Int()-1]->lineTo(x, y);
 }
 
 void GfxPath::curveTo(double x1, double y1, double x2, double y2,
@@ -3547,11 +3551,11 @@
       subpaths = (GfxSubpath **)
 	           greallocn(subpaths, size, sizeof(GfxSubpath *));
     }
-    subpaths[n] = new GfxSubpath(firstX, firstY);
+    subpaths[n.Int()] = new GfxSubpath(firstX, firstY);
     ++n;
     justMoved = gFalse;
   }
-  subpaths[n-1]->curveTo(x1, y1, x2, y2, x3, y3);
+  subpaths[n.Int()-1]->curveTo(x1, y1, x2, y2, x3, y3);
 }
 
 void GfxPath::close() {
@@ -3563,11 +3567,11 @@
       subpaths = (GfxSubpath **)
 	           greallocn(subpaths, size, sizeof(GfxSubpath *));
     }
-    subpaths[n] = new GfxSubpath(firstX, firstY);
+    subpaths[n.Int()] = new GfxSubpath(firstX, firstY);
     ++n;
     justMoved = gFalse;
   }
-  subpaths[n-1]->close();
+  subpaths[n.Int()-1]->close();
 }
 
 void GfxPath::append(GfxPath *path) {
@@ -3579,7 +3583,7 @@
                  greallocn(subpaths, size, sizeof(GfxSubpath *));
   }
   for (i = 0; i < path->n; ++i) {
-    subpaths[n++] = path->subpaths[i]->copy();
+    subpaths[(n++).Int()] = path->subpaths[i]->copy();
   }
   justMoved = gFalse;
 }
--- xpdf-3.02/xpdf/GfxState.h
+++ xpdf-3.02/xpdf/GfxState.h
@@ -942,7 +942,7 @@
   GBool *curve;			// curve[i] => point i is a control point
 				//   for a Bezier curve
   int n;			// number of points
-  int size;			// size of x/y arrays
+  SafeInt size;			// size of x/y arrays
   GBool closed;			// set if path is closed
 
   GfxSubpath(GfxSubpath *subpath);
@@ -968,12 +968,12 @@
   GBool isPath() { return n > 0; }
 
   // Get subpaths.
-  int getNumSubpaths() { return n; }
+  int getNumSubpaths() { return n.Int(); }
   GfxSubpath *getSubpath(int i) { return subpaths[i]; }
 
   // Get last point on last subpath.
-  double getLastX() { return subpaths[n-1]->getLastX(); }
-  double getLastY() { return subpaths[n-1]->getLastY(); }
+  double getLastX() { return subpaths[n.Int()-1]->getLastX(); }
+  double getLastY() { return subpaths[n.Int()-1]->getLastY(); }
 
   // Move the current point.
   void moveTo(double x, double y);
@@ -999,11 +999,11 @@
   GBool justMoved;		// set if a new subpath was just started
   double firstX, firstY;	// first point in new subpath
   GfxSubpath **subpaths;	// subpaths
-  int n;			// number of subpaths
-  int size;			// size of subpaths array
+  SafeInt n;			// number of subpaths
+  SafeInt size;			// size of subpaths array
 
   GfxPath(GBool justMoved1, double firstX1, double firstY1,
-	  GfxSubpath **subpaths1, int n1, int size1);
+	  GfxSubpath **subpaths1, SafeInt n1, SafeInt size1);
 };
 
 //------------------------------------------------------------------------
--- xpdf-3.02/xpdf/ImageOutputDev.cc
+++ xpdf-3.02/xpdf/ImageOutputDev.cc
@@ -26,7 +26,7 @@
 
 ImageOutputDev::ImageOutputDev(char *fileRootA, GBool dumpJPEGA) {
   fileRoot = copyString(fileRootA);
-  fileName = (char *)gmalloc(strlen(fileRoot) + 20);
+  fileName = (char *)gmalloc((SafeInt(strlen(fileRoot)) + SafeInt(20)).Int());
   dumpJPEG = dumpJPEGA;
   imgNum = 0;
   ok = gTrue;
--- xpdf-3.02/xpdf/JArithmeticDecoder.cc
+++ xpdf-3.02/xpdf/JArithmeticDecoder.cc
@@ -7,6 +7,7 @@
 //========================================================================
 
 #include <aconf.h>
+#include <stdlib.h>
 
 #ifdef USE_GCC_PRAGMAS
 #pragma implementation
@@ -47,6 +48,10 @@
 }
 
 void JArithmeticDecoderStats::setEntry(Guint cx, int i, int mps) {
+  if (cx >= contextSize) {
+    fprintf(stderr, "index out of bounds");
+    exit(1);
+  }
   cxTab[cx] = (i << 1) + mps;
 }
 
--- xpdf-3.02/xpdf/JBIG2Stream.cc
+++ xpdf-3.02/xpdf/JBIG2Stream.cc
@@ -684,7 +684,7 @@
 {
   w = wA;
   h = hA;
-  line = (wA + 7) >> 3;
+  line = (SafeInt(wA) + SafeInt(7) >> 3).Int();
   if (w <= 0 || h <= 0 || line <= 0 || h >= (INT_MAX - 1) / line) {
     // force a call to gmalloc(-1), which will throw an exception
     h = -1;
@@ -1522,7 +1522,7 @@
   }
 
   // get the input symbol bitmaps
-  bitmaps = (JBIG2Bitmap **)gmallocn(numInputSyms + numNewSyms,
+  bitmaps = (JBIG2Bitmap **)gmallocn(SafeInt(numInputSyms) + SafeInt(numNewSyms),
 				     sizeof(JBIG2Bitmap *));
   for (i = 0; i < numInputSyms + numNewSyms; ++i) {
     bitmaps[i] = NULL;
@@ -1845,7 +1845,8 @@
   int sOffset;
   Guint huffFlags, huffFS, huffDS, huffDT;
   Guint huffRDW, huffRDH, huffRDX, huffRDY, huffRSize;
-  Guint numInstances, numSyms, symCodeLen;
+  Guint numInstances, symCodeLen;
+  SafeInt numSyms;
   int atx[2], aty[2];
   Guint i, k, kk;
   int j;
@@ -2048,7 +2049,7 @@
     runLengthTab[35].prefixLen = 0;
     runLengthTab[35].rangeLen = jbig2HuffmanEOT;
     huffDecoder->buildTable(runLengthTab, 35);
-    symCodeTab = (JBIG2HuffmanTable *)gmallocn(numSyms + 1,
+    symCodeTab = (JBIG2HuffmanTable *)gmallocn(numSyms + SafeInt(1),
 					       sizeof(JBIG2HuffmanTable));
     for (i = 0; i < numSyms; ++i) {
       symCodeTab[i].val = i;
@@ -2070,9 +2071,9 @@
 	symCodeTab[i++].prefixLen = j;
       }
     }
-    symCodeTab[numSyms].prefixLen = 0;
-    symCodeTab[numSyms].rangeLen = jbig2HuffmanEOT;
-    huffDecoder->buildTable(symCodeTab, numSyms);
+    symCodeTab[numSyms.Int()].prefixLen = 0;
+    symCodeTab[numSyms.Int()].rangeLen = jbig2HuffmanEOT;
+    huffDecoder->buildTable(symCodeTab, numSyms.Int());
     huffDecoder->reset();
 
   // set up the arithmetic decoder
@@ -2086,7 +2087,7 @@
   }
 
   bitmap = readTextRegion(huff, refine, w, h, numInstances,
-			  logStrips, numSyms, symCodeTab, symCodeLen, syms,
+			  logStrips, numSyms.Int(), symCodeTab, symCodeLen, syms,
 			  defPixel, combOp, transposed, refCorner, sOffset,
 			  huffFSTable, huffDSTable, huffDTTable,
 			  huffRDWTable, huffRDHTable,
@@ -2638,6 +2639,7 @@
       error(getPos(), "Bad width in JBIG2 generic bitmap");
       // force a call to gmalloc(-1), which will throw an exception
       w = -3;
+      gmallocn(w + 2, sizeof(int));
     }
     refLine = (int *)gmallocn(w + 2, sizeof(int));
     codingLine = (int *)gmallocn(w + 2, sizeof(int));
@@ -3314,7 +3316,7 @@
   val = lowVal;
   while (val < highVal) {
     if (i == huffTabSize) {
-      huffTabSize *= 2;
+      huffTabSize = (SafeInt(huffTabSize) * 2).Int();
       huffTab = (JBIG2HuffmanTable *)
 	            greallocn(huffTab, huffTabSize, sizeof(JBIG2HuffmanTable));
     }
--- xpdf-3.02/xpdf/JPXStream.cc
+++ xpdf-3.02/xpdf/JPXStream.cc
@@ -652,7 +652,7 @@
       }
       palette.bpc = (Guint *)gmallocn(palette.nComps, sizeof(Guint));
       palette.c =
-          (int *)gmallocn(palette.nEntries * palette.nComps, sizeof(int));
+          (int *)gmallocn(SafeInt(palette.nEntries) * SafeInt(palette.nComps), sizeof(int));
       for (i = 0; i < palette.nComps; ++i) {
 	if (!readUByte(&palette.bpc[i])) {
 	  error(getPos(), "Unexpected EOF in JPX stream");
@@ -910,7 +910,7 @@
 	error(getPos(), "Bad tile count in JPX SIZ marker segment");
 	return gFalse;
       }
-      img.tiles = (JPXTile *)gmallocn(img.nXTiles * img.nYTiles,
+      img.tiles = (JPXTile *)gmallocn(SafeInt(img.nXTiles) * SafeInt(img.nYTiles),
 				      sizeof(JPXTile));
       for (i = 0; i < img.nXTiles * img.nYTiles; ++i) {
 	img.tiles[i].tileComps = (JPXTileComp *)gmallocn(img.nComps,
@@ -978,7 +978,7 @@
 	  }
 	  img.tiles[i].tileComps[comp].resLevels =
 	      (JPXResLevel *)gmallocn(
-		     (img.tiles[i].tileComps[comp].nDecompLevels + 1),
+		     (SafeInt(img.tiles[i].tileComps[comp].nDecompLevels) + SafeInt(1)),
 		     sizeof(JPXResLevel));
 	  for (r = 0; r <= img.tiles[i].tileComps[comp].nDecompLevels; ++r) {
 	    img.tiles[i].tileComps[comp].resLevels[r].precincts = NULL;
@@ -1055,7 +1055,7 @@
 	img.tiles[i].tileComps[comp].resLevels =
 	    (JPXResLevel *)greallocn(
 		     img.tiles[i].tileComps[comp].resLevels,
-		     (img.tiles[i].tileComps[comp].nDecompLevels + 1),
+		     (SafeInt(img.tiles[i].tileComps[comp].nDecompLevels) + SafeInt(1)),
 		     sizeof(JPXResLevel));
 	for (r = 0; r <= img.tiles[i].tileComps[comp].nDecompLevels; ++r) {
 	  img.tiles[i].tileComps[comp].resLevels[r].precincts = NULL;
@@ -1457,7 +1457,7 @@
 	img.tiles[tileIdx].tileComps[comp].resLevels =
 	    (JPXResLevel *)greallocn(
 		     img.tiles[tileIdx].tileComps[comp].resLevels,
-		     (img.tiles[tileIdx].tileComps[comp].nDecompLevels + 1),
+		     (SafeInt(img.tiles[tileIdx].tileComps[comp].nDecompLevels) + SafeInt(1)),
 		     sizeof(JPXResLevel));
 	for (r = 0;
 	     r <= img.tiles[tileIdx].tileComps[comp].nDecompLevels;
@@ -1512,7 +1512,7 @@
       img.tiles[tileIdx].tileComps[comp].resLevels =
 	  (JPXResLevel *)greallocn(
 		     img.tiles[tileIdx].tileComps[comp].resLevels,
-		     (img.tiles[tileIdx].tileComps[comp].nDecompLevels + 1),
+		     (SafeInt(img.tiles[tileIdx].tileComps[comp].nDecompLevels) + SafeInt(1)),
 		     sizeof(JPXResLevel));
       for (r = 0; r <= img.tiles[tileIdx].tileComps[comp].nDecompLevels; ++r) {
 	img.tiles[tileIdx].tileComps[comp].resLevels[r].precincts = NULL;
@@ -1775,15 +1775,15 @@
       tileComp->y1 = jpxCeilDiv(tile->y1, tileComp->hSep);
       tileComp->cbW = 1 << tileComp->codeBlockW;
       tileComp->cbH = 1 << tileComp->codeBlockH;
-      tileComp->data = (int *)gmallocn((tileComp->x1 - tileComp->x0) *
-				       (tileComp->y1 - tileComp->y0),
+      tileComp->data = (int *)gmallocn((SafeInt(tileComp->x1) - SafeInt(tileComp->x0)) *
+				       (SafeInt(tileComp->y1) - SafeInt(tileComp->y0)),
 				       sizeof(int));
       if (tileComp->x1 - tileComp->x0 > tileComp->y1 - tileComp->y0) {
 	n = tileComp->x1 - tileComp->x0;
       } else {
 	n = tileComp->y1 - tileComp->y0;
       }
-      tileComp->buf = (int *)gmallocn(n + 8, sizeof(int));
+      tileComp->buf = (int *)gmallocn(SafeInt(n) + SafeInt(8), sizeof(int));
       for (r = 0; r <= tileComp->nDecompLevels; ++r) {
 	resLevel = &tileComp->resLevels[r];
 	k = r == 0 ? tileComp->nDecompLevels
@@ -1844,7 +1844,7 @@
 	    for (level = subband->maxTTLevel; level >= 0; --level) {
 	      nx = jpxCeilDivPow2(subband->nXCBs, level);
 	      ny = jpxCeilDivPow2(subband->nYCBs, level);
-	      n += nx * ny;
+	      n += (SafeInt(nx) * SafeInt(ny)).Int();
 	    }
 	    subband->inclusion =
 	        (JPXTagTreeNode *)gmallocn(n, sizeof(JPXTagTreeNode));
@@ -1856,8 +1856,8 @@
 	      subband->zeroBitPlane[k].finished = gFalse;
 	      subband->zeroBitPlane[k].val = 0;
 	    }
-	    subband->cbs = (JPXCodeBlock *)gmallocn(subband->nXCBs *
-						      subband->nYCBs,
+	    subband->cbs = (JPXCodeBlock *)gmallocn(SafeInt(subband->nXCBs) *
+						      SafeInt(subband->nYCBs),
 						    sizeof(JPXCodeBlock));
 	    sbx0 = jpxFloorDivPow2(subband->x0, tileComp->codeBlockW);
 	    sby0 = jpxFloorDivPow2(subband->y0, tileComp->codeBlockH);
@@ -1885,8 +1885,8 @@
 		cb->nextPass = jpxPassCleanup;
 		cb->nZeroBitPlanes = 0;
 		cb->coeffs =
-		    (JPXCoeff *)gmallocn((1 << (tileComp->codeBlockW
-						+ tileComp->codeBlockH)),
+		    (JPXCoeff *)gmallocn((SafeInt(1) << (SafeInt(tileComp->codeBlockW)
+						+ SafeInt(tileComp->codeBlockH)).Int()),
 					 sizeof(JPXCoeff));
 		for (cbi = 0;
 		     cbi < (Guint)(1 << (tileComp->codeBlockW
--- xpdf-3.02/xpdf/Link.cc
+++ xpdf-3.02/xpdf/Link.cc
@@ -725,7 +725,7 @@
 Links::Links(Object *annots, GString *baseURI) {
   Link *link;
   Object obj1, obj2;
-  int size;
+  SafeInt size;
   int i;
 
   links = NULL;
--- xpdf-3.02/xpdf/NameToCharCode.cc
+++ xpdf-3.02/xpdf/NameToCharCode.cc
@@ -49,7 +49,8 @@
 
 void NameToCharCode::add(char *name, CharCode c) {
   NameToCharCodeEntry *oldTab;
-  int h, i, oldSize;
+  int h, i;
+  SafeInt oldSize;
 
   // expand the table if necessary
   if (len >= size / 2) {
@@ -112,5 +113,5 @@
   for (p = name; *p; ++p) {
     h = 17 * h + (int)(*p & 0xff);
   }
-  return (int)(h % size);
+  return (int)(h % size.Int());
 }
--- xpdf-3.02/xpdf/NameToCharCode.h
+++ xpdf-3.02/xpdf/NameToCharCode.h
@@ -35,7 +35,7 @@
   int hash(char *name);
 
   NameToCharCodeEntry *tab;
-  int size;
+  SafeInt size;
   int len;
 };
 
--- xpdf-3.02/xpdf/PSOutputDev.cc
+++ xpdf-3.02/xpdf/PSOutputDev.cc
@@ -2253,11 +2253,11 @@
     if (fontFileNameLen >= fontFileNameSize) {
       fontFileNameSize += 64;
       fontFileNames =
-	(GString **)grealloc(fontFileNames,
-			     fontFileNameSize * sizeof(GString *));
+	(GString **)greallocn(fontFileNames,
+			      fontFileNameSize, sizeof(GString *));
       psFileNames =
-	(GString **)grealloc(psFileNames,
-			     fontFileNameSize * sizeof(GString *));
+	(GString **)greallocn(psFileNames,
+			      fontFileNameSize, sizeof(GString *));
     }
   }
   fontFileNames[fontFileNameLen] = myFileName;
@@ -2274,7 +2274,7 @@
   if ((ffTT = FoFiTrueType::load(fileName->getCString(), faceIndex))) {
       int n = ((GfxCIDFont *)font)->getCIDToGIDLen();
       if (n) {
-	codeToGID = (Gushort *)gmalloc(n * sizeof(Gushort));
+	codeToGID = (Gushort *)gmallocn(n, sizeof(Gushort));
 	memcpy(codeToGID, ((GfxCIDFont *)font)->getCIDToGID(), n * sizeof(Gushort));
       } else {
 	codeToGID = ((GfxCIDFont *)font)->getCodeToGIDMap(ffTT, &n);
@@ -4412,7 +4412,7 @@
 	     width, -height, height);
 
   // allocate a line buffer
-  lineBuf = (Guchar *)gmalloc(4 * width);
+  lineBuf = (Guchar *)gmallocn(4, width);
 
   // set up to process the data stream
   imgStr = new ImageStream(str, width, colorMap->getNumPixelComps(),
@@ -4465,7 +4465,8 @@
   ImageStream *imgStr;
   Guchar *line;
   PSOutImgClipRect *rects0, *rects1, *rectsTmp, *rectsOut;
-  int rects0Len, rects1Len, rectsSize, rectsOutLen, rectsOutSize;
+  int rects0Len, rects1Len, rectsOutLen;
+  SafeInt rectsOutSize, rectsSize;
   GBool emitRect, addRect, extendRect;
   GString *s;
   int n, numComps;
--- xpdf-3.02/xpdf/PSOutputDev.h
+++ xpdf-3.02/xpdf/PSOutputDev.h
@@ -328,10 +328,10 @@
 
   Ref *fontIDs;			// list of object IDs of all used fonts
   int fontIDLen;		// number of entries in fontIDs array
-  int fontIDSize;		// size of fontIDs array
+  SafeInt fontIDSize;		// size of fontIDs array
   Ref *fontFileIDs;		// list of object IDs of all embedded fonts
   int fontFileIDLen;		// number of entries in fontFileIDs array
-  int fontFileIDSize;		// size of fontFileIDs array
+  SafeInt fontFileIDSize;	// size of fontFileIDs array
   GString **fontFileNames;	// list of names of all embedded external fonts
   GString **psFileNames;	// list of names of all embedded external ps names
   int fontFileNameLen;		// number of entries in fontFileNames array
@@ -340,16 +340,16 @@
 				//   font name
   PSFont8Info *font8Info;	// info for 8-bit fonts
   int font8InfoLen;		// number of entries in font8Info array
-  int font8InfoSize;		// size of font8Info array
+  SafeInt font8InfoSize;	// size of font8Info array
   PSFont16Enc *font16Enc;	// encodings for substitute 16-bit fonts
   int font16EncLen;		// number of entries in font16Enc array
-  int font16EncSize;		// size of font16Enc array
+  SafeInt font16EncSize;	// size of font16Enc array
   Ref *imgIDs;			// list of image IDs for in-memory images
   int imgIDLen;			// number of entries in imgIDs array
-  int imgIDSize;		// size of imgIDs array
+  SafeInt imgIDSize;		// size of imgIDs array
   Ref *formIDs;			// list of IDs for predefined forms
   int formIDLen;		// number of entries in formIDs array
-  int formIDSize;		// size of formIDs array
+  SafeInt formIDSize;		// size of formIDs array
   GList *xobjStack;		// stack of XObject dicts currently being
 				//   processed
   int numSaves;			// current number of gsaves
